#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "basic.h"
#include "error.h"


ErrorDefinition runtime_error_message[] = {
    "dummy",
    "配列変数の添字がDIM命令で宣言した大きさを超えている。",
    "DIM命令で宣言していない配列変数を使用している。",
    "変数が見つかりません。",
    "数値変数に文字、文字変数に数値を代入しようとした。",    
    "すでに宣言されている配列変数名を再度宣言している。",
    "メモリを確保できません。",
    "文法的に実行できない。",
    "指定したラベルが存在しない。",
    "指定したラベルが重複している。",
    "READ文に対するDATA文がない。",
    "指定している数値が規定の範囲から外れている。",
    "除数が0の除算を実行した。",
    "FOR文に対するNEXT文がない。",
    "NEXT文に対するFOR文がない。",
    "RETURN文に対するGOSUB文がない。",
    "不合理な演算、計算範囲外の値の関数計算を行った。",
   
    "計算結果が1x10^100以上になった。",
    "GOSUB、FOR、REPEAT、WHILEもしくはSWITCHでの段数オーバー。",
    "dummy"
};


void runtime_error(int line_number, RuntimeError format) {
    print_esc();
    fprintf(stderr, "%d: %s\n", line_number, runtime_error_message[format].format);
}

void runtime_error_no_line(RuntimeError format) {
    print_esc();
    fprintf(stderr, "%s\n", runtime_error_message[format].format);
}

void error_exit(int status) {    
    exit(status);
}

void print_esc() {

/* #if defined(linux) */
	
#if defined(__APPLE__)
	fprintf(stderr, "\x1b[%dm", 30);   /* 30:黒 */
    fprintf(stdout, "\x1b[%dm", 30);
#else
    fprintf(stderr, "\x1b[%dm", 37);	/* 37:白 */
    fprintf(stdout, "\x1b[%dm", 37);
#endif
    
}
