#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include "basic.h"

char *Usage[] = {
	"basic version 1.0.0",
	"Copyright (C) 2012 KOYAMA Yoshiaki.",
	"usage: basic FILE",
	NULL
};

void print_usage() {
	int i;
	
	for (i=0; Usage[i] != NULL; i++) {
		printf("%s\n", Usage[i]);
	}	
}

/*
    Main
 */

int main(int argc, char * argv[])
{
    FILE *fp;
    StatementList *p;
    time_t seed;
    
    if (argc == 1) {
        fp = fopen("a.bas.txt", "r");
    
        if (fp == NULL) {    
            print_usage();
            exit(1);
        }    
    } else {
        fp = fopen(argv[1], "r");
    }
    
    if (fp == NULL) {
        fprintf(stderr, "basic: %s: No such file\n", argv[1]);
        fprintf(stderr, "basic: no input file\n");
        exit(1);
    } else {
        yyin = fp;
    }
    
    seed = time(NULL);
    srand(seed);
/*  sranddev();*/

    yyparse();
    
    executePointer = top;

    print_type = EMPTY_START_EXPRESSION;

    dataPointer.dataStatement = top;
    dataPointer.dataExpression = NULL;
    
    eval_statements();

    if ((print_type != EMPTY_EXPRESSION) && (print_type != EMPTY_START_EXPRESSION)) {
        putchar('\n');
    }
    print_esc();
}


void basic_exit() {
    if ((print_type != EMPTY_EXPRESSION) && (print_type != EMPTY_START_EXPRESSION)) {
        putchar('\n');
    }
    print_esc();
    exit(0);
}
