#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "basic.h"
#include "error.h"

/*  "ｱｲｳｴｵ" */    /* 177 */
/*  "ｶｷｸｹｺ" */
/*  "ｻｼｽｾｿ" */
/*  "ﾀﾁﾂﾃﾄ" */
/*  "ﾅﾆﾇﾈﾉ" */
/*  "ﾊﾋﾌﾍﾎ" */
/*  "ﾏﾐﾑﾒﾓ" */    /* 207 */
/*  "ﾔﾕﾖ"   */    /* 212 */
/*  "ﾗﾘﾙﾚﾛ" */    /* 215 */
/*  "ﾜﾝ"    */    /* 220 */
/*  "ｦ"     */   /* 166 */ 

/*
 
 !\"#$%&'()*+,-./0123456789:;<=>?",
 @ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~
 
 ｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜｦﾝｧｨｩｪｫｬｭｮｯｰﾞﾟ｡｢｣､･ 
 */

typedef struct {
    int ascii;
    char *asciiChar;
} CharTable;

/* #define ASCII_CHAR_TABLE_SIZE   255 */

#define ASCII_CHAR_TABLE_SIZE   (5+1+5+4+1+45+1)

CharTable table[] = {
    {161,"｡"},{162,"｢"},{163,"｣"},{164,"､"},{165,"･"},
        
    {166,"ｦ"},    
    
    {167,"ｧ"},{168,"ｨ"},{169,"ｩ"},{170,"ｪ"},{171,"ｫ"},
    
    {172,"ｬ"},{173,"ｭ"},{174,"ｮ"},{175,"ｯ"},
    
    {176,"-"},
    
    {177,"ｱ"},{178,"ｲ"},{179,"ｳ"},{180,"ｴ"},{181,"ｵ"}, /* 45 */
    {182,"ｶ"},{183,"ｷ"},{184,"ｸ"},{185,"ｹ"},{186,"ｺ"},
    {187,"ｻ"},{188,"ｼ"},{189,"ｽ"},{190,"ｾ"},{191,"ｿ"},
    {192,"ﾀ"},{193,"ﾁ"},{194,"ﾂ"},{195,"ﾃ"},{196,"ﾄ"},
    {197,"ﾅ"},{198,"ﾆ"},{199,"ﾇ"},{200,"ﾈ"},{201,"ﾉ"},
    {202,"ﾊ"},{203,"ﾋ"},{204,"ﾌ"},{205,"ﾍ"},{206,"ﾎ"},
    {207,"ﾏ"},{208,"ﾐ"},{209,"ﾑ"},{210,"ﾒ"},{211,"ﾓ"},
    {212,"ﾔ"},{213,"ﾕ"},{214,"ﾖ"},
    {215,"ﾗ"},{216,"ﾘ"},{217,"ﾙ"},{218,"ﾚ"},{219,"ﾛ"},
    {220,"ﾜ"},{221,"ﾝ"},
    
    {222,"\""}
};

/*
 
 */
char *create_identifier(char *str)
{
    char *name;
    int i;
    size_t size;
    
    size = strlen(str)+1;
    name = malloc(size);
    
    if(!name) {
        yyerror(runtime_error_message[OUT_OF_MEMORY_SPACE_ERR].format);
    }
    
    /* 変数の大文字・小文字の区別しない場合 */
    /*
     for (i=0; i<size-1; i++) {
     name[i] = tolower(str[i]);
     }
     */    
    strcpy(name, str);
    name[strlen(str)] = 0;
    
    return name;
}

void open_string_literial() {
    char *ptr;
    string_literial_buffer_size = 0;
    
    if (string_literial_buffer == NULL) {

        ptr = malloc(STRING_BUFFER_SIZE+1);

        string_literial_buffer = ptr;

        if(!ptr) {
            yyerror(runtime_error_message[OUT_OF_MEMORY_SPACE_ERR].format);
        }
    }

    string_literial_buffer[0]= '\0';
}

void add_string_literal(char ch) {
    string_literial_buffer[string_literial_buffer_size++] = ch;
    string_literial_buffer[string_literial_buffer_size] = '\0';
}

char *string_value_strcat(char *s1, char *s2) {
    char *a;
    size_t size;
    
    size = strlen(s1)+strlen(s2)+1;
    a = malloc(size);
    
    if(!a) {
        runtime_error_no_line(OUT_OF_MEMORY_SPACE_ERR);
        exit(1);
    }
    
    a = strcpy(a,s1);
    strcat(a,s2);
    a[size-1] = 0;
    
    return a;    
}

char *string_value(char *s) {
    char *a;
    size_t size;
    
    
    size = strlen(s)+1;
    a = malloc(size);
    
    if(!a) {
        runtime_error_no_line(OUT_OF_MEMORY_SPACE_ERR);
        exit(1);
    }
    
    a = strcpy(a,s);
    a[size-1] = 0;            
    
    return a;    
}

void fill_string_zero(char *s, int size) {
    int i;
    
    for (i=0; i<size; i++) {
        s[i] = '\0';
    }
}

/*
 
 */
char *string_value_int(int data) {
    char *ptr;
    unsigned char c;
    char buffer[256];
    int i;
    
    ptr = NULL;
    
    for (i=0; i<ASCII_CHAR_TABLE_SIZE; i++) {

        if (table[i].ascii == data) {
            ptr = table[i].asciiChar;
            break;
        }
    }

    if (ptr == NULL) {
        c = (unsigned char)data;                
        
        buffer[0] = c;
        buffer[1] = 0;
     
        ptr = buffer;
    }
    
    return string_value(ptr);
}

/*
 
 */
char *strmid(char *source, int location, int size) {
    char *ptr;
    char buffer[256];
    size_t len;
    
    len = strlen(source);

    if (location >= len) {
        buffer[0] = '\0';
    } else {
        ptr = &source[location];
        strncpy(buffer, ptr, (size_t)size);
        if (size < 256) {
            buffer[size] = 0;
        } else {
            buffer[255] = 0;            
        }
    }
    
    return string_value(buffer);;
}

/*
 
 */
int ascii_char(char *char_string) {
    unsigned char ch;
    int i;
    
    for (i=0; i<ASCII_CHAR_TABLE_SIZE; i++) {
        
        if (strcmp(table[i].asciiChar,char_string) == 0) {
            return table[i].ascii;
        }
    }
    
    ch = char_string[0];

    return (int)ch;
}

